(define-module (ui net-bl ajax)
    :use-module (alterator ajax)
    :use-module (alterator woo)
    :use-module (alterator algo)
    :export (init))

(define (read-from-backend)
  (catch/message (lambda ()
    (form-update-enum "ip" (woo-list "/net-bl" 'ipv (form-value "ipv")))
    (form-update-value-list
      '("status" "ip" "commit_mode") (woo-read-first "/net-bl" 'ipv (form-value "ipv"))) ))
  (form-update-visibility "manmode_warn" (not (form-value "commit_mode"))))

(define (switch)
  (catch/message (lambda ()
    (woo "switch" "/net-bl" 'status (form-value "status") 'ipv (form-value "ipv")))))

(define (add)
  (catch/message (lambda ()
    (woo "add" "/net-bl" 'new_ip (form-value "new_ip") 'ipv (form-value "ipv")) ))
  (form-update-value "new_ip" "")
  (read-from-backend))

(define (del)
  (catch/message (lambda ()
    (woo "del" "/net-bl"
      'ip (form-value "ip" 'ipv (form-value "ipv")) )))
  (read-from-backend))

(define (init-ui)
  (catch/message (lambda()
    (let ((available-ip-versions (woo-list "/net-iptables/ipv" 'language (form-value "language"))))
      (form-update-enum "ipv" available-ip-versions)
      ;; Don't show IP version selector if only one IP version is available
      (form-update-visibility "area-ipv-select" (not (= (length available-ip-versions) 1))))))
  (form-update-value "ipv" "4")
  (read-from-backend))


(define (init)
  (init-ui)
  (form-bind "ipv"     "change" read-from-backend)
  (form-bind "status"  "change" switch)
  (form-bind "add"     "click"  add)
  (form-bind "del"     "click"  del) )

